import type { PluginPass } from '@babel/core';
import type { JSXOpeningElement, Node } from '@babel/types';
import type { Visitor } from '@babel/traverse';
/**
 * simple path match method, only use string and regex
 */
export declare const pathMatch: (filePath: string, matches?: (string | RegExp)[] | undefined) => boolean;
declare type NodeHandler<T = Node, O = void> = (node: T, option: O) => {
    /**
     * stop processing flag
     */
    stop?: boolean;
    /**
     * throw error
     */
    error?: any;
    /**
     * node after processing
     */
    result?: Node;
};
export declare const doJSXOpeningElement: NodeHandler<JSXOpeningElement, {
    relativePath: string;
}>;
export declare const createVisitor: ({ cwd, excludes }: {
    cwd?: string | undefined;
    excludes?: (string | RegExp)[] | undefined;
}) => Visitor<PluginPass>;
export {};
