"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.inspectorChainWebpack = void 0;
const inspector_plugin_1 = require("./inspector-plugin");
const inspectorChainWebpack = (config, inspectorConfig) => {
    if ((inspectorConfig === null || inspectorConfig === void 0 ? void 0 : inspectorConfig.exclude) && !(inspectorConfig === null || inspectorConfig === void 0 ? void 0 : inspectorConfig.excludes)) {
        inspectorConfig.excludes = inspectorConfig.exclude;
        delete inspectorConfig.exclude;
    }
    /**
     * [compile time] for inject source code file info
     */
    config
        .module
        .rule('inspector')
        .enforce('pre')
        .test(/\.[jt]sx$/)
        .exclude
        .add(/node_modules/)
        .add(/\.umi(-production)?\//)
        .add(/\/devTools\//)
        .add(/\.storybook\//)
        .end()
        .use('inspector')
        .loader(require.resolve('./inspector-loader'))
        .options(inspectorConfig !== null && inspectorConfig !== void 0 ? inspectorConfig : {})
        .end();
    /**
     * [server side] add webpack dev server middleware for launch IDE app with api request
     */
    config
        .plugin('react-inspector')
        .use(inspector_plugin_1.ReactInspectorPlugin, []);
    return config;
};
exports.inspectorChainWebpack = inspectorChainWebpack;
